#!/usr/bin/python
# -*- coding: UTF-8 -*-
# author:workdev
# file:huarongdao.py
# time:2022/01/25
import uos
import machine
import st7789 as st7789
from fonts import vga1_16x32 as font2
import time
import random

class ImgSplit:# 图片分割的块
	maxX=2
	maxY=2
	
	
width = 240
height = 240
res = 0
dc = 1
spi_sck = machine.Pin(2)
spi_tx = machine.Pin(3)
keyA=machine.Pin(5,machine.Pin.IN)

class ImgIterm():
    def __init__(self, pos):
        self.pos = pos  # 当前位置
        self.disp = True  # 是否显示


class HRDGame():
    # 初始化
    def __init__(self):
        spi0 = machine.SPI(0, baudrate=4000000, phase=1, polarity=1, sck=spi_sck, mosi=spi_tx)
        self.disp = st7789.ST7789(spi0, width, height, reset=machine.Pin(res, machine.Pin.OUT),
                                  dc=machine.Pin(dc, machine.Pin.OUT), xstart=0, ystart=0, rotation=0)
        self.disp.fill(st7789.RED)
        self.step = 0  # 移动了的步骤
        self.image = open('girl.bmp', 'rb')
        #self.image = open('bdd.bmp', 'rb')
        self.imagesplit_X = int(240 / ImgSplit.maxX)
        self.imagesplit_Y = int(240 / ImgSplit.maxY)
        self.imglist = []  # 图片列表
        for i in range(0, ImgSplit.maxX * ImgSplit.maxY):
            node = ImgIterm(i)
            self.imglist.append(node)
        node.disp = False
        self.disp.text(font2,str(ImgSplit.maxX)+' X '+str(ImgSplit.maxY),80,70,color=st7789.GREEN, background=st7789.RED)
        self.disp.text(font2,"Pass B key ",40,110,color=st7789.GREEN, background=st7789.RED)
        self.disp.text(font2,"TO START ",60,150,color=st7789.GREEN, background=st7789.RED)
        while keyA.value():
            pass

    def readImgAndDraw(self, nodepos):  # 绘制指定节点 输入为 队列的号
        # 读取指定位置图像，然后在指定位置绘制图像
        x = int(nodepos % ImgSplit.maxX)
        y = int(nodepos / ImgSplit.maxX)
        node = self.imglist[nodepos]
        t_x = int(node.pos % ImgSplit.maxX)
        t_y = int(node.pos / ImgSplit.maxX)
        if node.disp:
            offset = y * self.imagesplit_Y * 480
            self.image.seek(offset)
            for column in range(0, self.imagesplit_Y):
                buf = self.image.read(480)
                buf = buf[x * self.imagesplit_X * 2:(x + 1) * self.imagesplit_X * 2]
                self.disp.blit_buffer(buf, t_x * self.imagesplit_X, t_y * self.imagesplit_Y + column, self.imagesplit_X,
                                      1)
        else:
            self.disp.fill_rect(t_x * self.imagesplit_X, t_y * self.imagesplit_Y, self.imagesplit_X, self.imagesplit_Y,
                                st7789.CYAN)

    def reset(self):
        self._messimg()
        self.step = 0
        self.imglist[-1].disp = False
        self.rander()

    def rander(self, changeblock=None):  # 绘制图片
        if self.step == 0:
            for i in range(ImgSplit.maxX * ImgSplit.maxY):
                self.readImgAndDraw(i)
        else:
            self.readImgAndDraw(ImgSplit.maxX * ImgSplit.maxY - 1)
            self.readImgAndDraw(changeblock)

    def checkover(self):  # 检查是否拼完
        i = 0
        for node in self.imglist:
            if node.pos != i:
                return False
            i += 1
        #拼图完成
        self.imglist[-1].disp=True
        return True

    def _messimg(self):  # 游戏开始时，对图像进行打乱
        maxstep=ImgSplit.maxX*ImgSplit.maxY*8
        for i in range(maxstep):
        #for i in range(10):
            act = random.randint(0, 3)
            self.action(act)

    def action(self, deal):  # 移动 入口：0，1，2，3 代表上下左右
        '''
         单步移动步骤，1 找到不显示的色块
         2 按动作寻找 相邻的色块
         3 如果能找到 则进行移动，返回True，否则返回False
         4 返回值为 是否允许移动，移动的色块
        '''
        self.step += 1  # 移动步骤增加
        cave = self.imglist[-1]
        tpos = cave.pos  # 黑洞坐标
        hx = int(tpos % ImgSplit.maxX)
        hy = int(tpos / ImgSplit.maxX)
        newtpos = None
        if deal == 0:  # 上移
            if hy == 0:  # 禁止上移
                return False, None, False
            else:  # 允许移动
                hy = hy - 1
                newtpos = hy * ImgSplit.maxX + hx
        if deal == 1:  # 下移
            if hy + 1 == ImgSplit.maxY:  # 禁止下移
                return False, None, False
            else:  # 允许移动
                hy = hy + 1
                newtpos = hy * ImgSplit.maxX + hx

        if deal == 2:  # 左移
            if hx == 0:  # 禁止左移
                return False, None, False
            else:  # 允许移动
                hx = hx - 1
                newtpos = hy * ImgSplit.maxX + hx
        if deal == 3:  # 右移
            if hx + 1 == ImgSplit.maxX:  # 禁止右移
                return False, None, False
            else:  # 允许移动
                hx = hx + 1
                newtpos = hy * ImgSplit.maxX + hx
        # 允许移动，交换坐标
        offset = 0
        for iterm in self.imglist:
            if iterm.pos == newtpos:
                break
            offset += 1
        cave.pos = newtpos
        iterm.pos = tpos
        done = self.checkover()
        return True, offset, done






